/* -*- C -*- */
/*
 * Assembler/Disassembler for DOCSIS cable modem configuration files
 *
 * $Id: hmac_md5.h,v 1.1 2000/03/01 23:19:37 petras Exp $
 * 
 * Copyright (C) 2000  Dietmar Petras  <Dietmar.Petras@ELSA.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * History:
 * $Log: hmac_md5.h,v $
 * Revision 1.1  2000/03/01 23:19:37  petras
 * Initial revision.
 *
 */

#ifndef _HMAC_MD5_H
#define _HMAC_MD5_H

#include "md5.h"

extern void HMAC_MD5Init  (struct MD5Context *context, const unsigned char *secret, int len);
extern void HMAC_MD5Update(struct MD5Context *context, const unsigned char *buf, int len);
extern void HMAC_MD5Final (unsigned char digest[16], struct MD5Context *context);

#endif /* _HMAC_MD5_H */


/* {{{ Local variables */

/*
  Local variables:
  folded-file: t
  c-basic-offset: 2
  End:
*/

/* }}} */
