
/*  A Bison parser, made from yaccan.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	DOWN_FREQ	257
#define	UP_CHAN_ID	258
#define	NETWORK_ACCESS	259
#define	COS	260
#define	MODEM_CAP	261
#define	VENDOR_ID	262
#define	UPGRADE_FILENAME	263
#define	SNMP_WRITE_ACCESS	264
#define	SNMP_MIB_OBJECT	265
#define	CPE_MAC_ADDR	266
#define	BPI	267
#define	MAX_NUM_CPE	268
#define	UPGRADE_SERVER	269
#define	VENDOR_SPECIFIC_INFO	270
#define	CLASS_ID	271
#define	MAX_DOWN_RATE	272
#define	MAX_UP_RATE	273
#define	UP_CHAN_PRIO	274
#define	MIN_UP_RATE	275
#define	MAX_BURST_SIZE	276
#define	COS_BPI_ENABLE	277
#define	CONCATENATION	278
#define	AUTHORIZE_WAIT_TIMEOUT	279
#define	REAUTHORIZE_WAIT_TIMEOUT	280
#define	AUTHORIZATION_GRACE_TIME	281
#define	OPERATIONAL_WAIT_TIMEOUT	282
#define	REKEY_WAIT_TIMEOUT	283
#define	TEK_GRACE_TIME	284
#define	AUTHORIZE_REJECT_WAIT_TIMEOUT	285
#define	INTEGER	286
#define	OCTET_STRING	287
#define	NULL_OBJ	288
#define	OBJECT_ID	289
#define	IPADDRESS	290
#define	IS	291
#define	OPEN_BRACKET	292
#define	CLOSE_BRACKET	293
#define	SEMICOLON	294
#define	ON	295
#define	OFF	296
#define	ENABLE	297
#define	DISABLE	298
#define	ALLOW	299
#define	DISALLOW	300
#define	NUMBER	301
#define	BYTE	302
#define	STRING	303
#define	IP_ADDR_STRING	304
#define	MAC_ADDR_STRING	305
#define	SNMP_OBJ_ID	306


#line 64 "yaccan.y"
typedef union {
   unsigned long	ulong_val;
   unsigned char	byte_val;
   char			*string_val;
   int			bool_val;
} YYSTYPE;
#line 71 "yaccan.y"


/*-----------------------------------------------------------------------*
 * $Log: yaccan.y,v $
 * Revision 1.4  2001/02/15 05:38:39  petras
 * Minor bug fix
 *
 * Revision 1.3  2001/02/13 10:03:43  petras
 * It is now possible to include each valid TLV within vendor specific
 * information.
 *
 * Revision 1.2  2000/07/27 16:18:35  petras
 * Bug fix with reallocation of OutputBuffer
 *
 * Revision 1.1  2000/03/01 23:19:38  petras
 * Initial revision.
 *
 *-----------------------------------------------------------------------*/

int yylex(YYSTYPE *yylval);
#include "lexan.h"
#define YYDEBUG 1
#define YYERROR_VERBOSE

void yyerror (const char*);

#include "docas.h"
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

int DefiningVendorSpecific = 0;

#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		161
#define	YYFLAG		-32768
#define	YYNTBASE	53

#define YYTRANSLATE(x) ((unsigned)(x) <= 306 ? yytranslate[x] : 80)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,    10,    13,    15,    17,    18,    24,
    25,    31,    32,    38,    39,    40,    53,    57,    61,    65,
    71,    75,    80,    85,    89,    93,    97,   100,   104,   107,
   108,   112,   116,   120,   124,   128,   132,   136,   139,   143,
   146,   150,   153,   157,   160,   164,   168,   172,   176,   180,
   184,   188,   189,   192,   196,   199,   201,   203,   206,   209,
   212,   214,   217,   220,   222,   224,   226,   228,   230,   232,
   234,   236,   238,   240,   243,   245
};

static const short yyrhs[] = {    54,
     0,     0,    54,    55,     0,    54,    63,    40,     0,    54,
     1,     0,    56,     0,    60,     0,     0,     6,    38,    57,
    64,    39,     0,     0,     7,    38,    58,    66,    39,     0,
     0,    13,    38,    59,    68,    39,     0,     0,     0,    16,
    38,    61,     8,    37,    48,    48,    48,    40,    62,    70,
    39,     0,     3,    37,    76,     0,     4,    37,    76,     0,
     5,    37,    74,     0,     8,    37,    48,    48,    48,     0,
     9,    37,    49,     0,    10,    37,    49,    75,     0,    11,
    71,    37,    73,     0,    12,    37,    79,     0,    14,    37,
    76,     0,    15,    37,    78,     0,    65,    40,     0,    64,
    65,    40,     0,    64,     1,     0,     0,    17,    37,    76,
     0,    18,    37,    76,     0,    19,    37,    76,     0,    20,
    37,    76,     0,    21,    37,    76,     0,    22,    37,    76,
     0,    23,    37,    74,     0,    67,    40,     0,    66,    67,
    40,     0,    66,     1,     0,    24,    37,    74,     0,    69,
    40,     0,    68,    69,    40,     0,    68,     1,     0,    25,
    37,    76,     0,    26,    37,    76,     0,    27,    37,    76,
     0,    28,    37,    76,     0,    29,    37,    76,     0,    30,
    37,    76,     0,    31,    37,    76,     0,     0,    54,    56,
     0,    54,    63,    40,     0,    54,     1,     0,    72,     0,
    52,     0,    32,    76,     0,    33,    49,     0,    33,    77,
     0,    34,     0,    35,    71,     0,    36,    78,     0,     1,
     0,    41,     0,    42,     0,    43,     0,    44,     0,    45,
     0,    46,     0,    47,     0,    48,     0,    48,     0,    77,
    48,     0,    50,     0,    51,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   108,   110,   111,   112,   113,   116,   117,   120,   124,   128,
   132,   136,   140,   146,   154,   162,   168,   187,   204,   211,
   219,   236,   239,   270,   277,   294,   303,   304,   305,   307,
   308,   324,   330,   336,   352,   358,   374,   382,   383,   384,
   386,   395,   396,   397,   399,   415,   431,   447,   463,   479,
   495,   503,   504,   505,   506,   509,   543,   591,   611,   623,
   635,   643,   655,   666,   674,   678,   682,   686,   692,   696,
   702,   703,   710,   725,   744,   774
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","DOWN_FREQ",
"UP_CHAN_ID","NETWORK_ACCESS","COS","MODEM_CAP","VENDOR_ID","UPGRADE_FILENAME",
"SNMP_WRITE_ACCESS","SNMP_MIB_OBJECT","CPE_MAC_ADDR","BPI","MAX_NUM_CPE","UPGRADE_SERVER",
"VENDOR_SPECIFIC_INFO","CLASS_ID","MAX_DOWN_RATE","MAX_UP_RATE","UP_CHAN_PRIO",
"MIN_UP_RATE","MAX_BURST_SIZE","COS_BPI_ENABLE","CONCATENATION","AUTHORIZE_WAIT_TIMEOUT",
"REAUTHORIZE_WAIT_TIMEOUT","AUTHORIZATION_GRACE_TIME","OPERATIONAL_WAIT_TIMEOUT",
"REKEY_WAIT_TIMEOUT","TEK_GRACE_TIME","AUTHORIZE_REJECT_WAIT_TIMEOUT","INTEGER",
"OCTET_STRING","NULL_OBJ","OBJECT_ID","IPADDRESS","IS","OPEN_BRACKET","CLOSE_BRACKET",
"SEMICOLON","ON","OFF","ENABLE","DISABLE","ALLOW","DISALLOW","NUMBER","BYTE",
"STRING","IP_ADDR_STRING","MAC_ADDR_STRING","SNMP_OBJ_ID","input","commands",
"group","recursive_group","@1","@2","@3","vendor_group","@4","@5","command",
"cos_commands","cos_command","modem_cap_commands","modem_cap_command","bpi_commands",
"bpi_command","vendor_specific_info_commands","snmp_obj_id","pre_snmp_obj_id",
"snmp_type_value","enabled_disabled","allow_disallow","number","byte_sequence",
"ip_addr","mac_addr", NULL
};
#endif

static const short yyr1[] = {     0,
    53,    54,    54,    54,    54,    55,    55,    57,    56,    58,
    56,    59,    56,    61,    62,    60,    63,    63,    63,    63,
    63,    63,    63,    63,    63,    63,    64,    64,    64,    65,
    65,    65,    65,    65,    65,    65,    65,    66,    66,    66,
    67,    68,    68,    68,    69,    69,    69,    69,    69,    69,
    69,    70,    70,    70,    70,    71,    72,    73,    73,    73,
    73,    73,    73,    73,    74,    74,    74,    74,    75,    75,
    76,    76,    77,    77,    78,    79
};

static const short yyr2[] = {     0,
     1,     0,     2,     3,     2,     1,     1,     0,     5,     0,
     5,     0,     5,     0,     0,    12,     3,     3,     3,     5,
     3,     4,     4,     3,     3,     3,     2,     3,     2,     0,
     3,     3,     3,     3,     3,     3,     3,     2,     3,     2,
     3,     2,     3,     2,     3,     3,     3,     3,     3,     3,
     3,     0,     2,     3,     2,     1,     1,     2,     2,     2,
     1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     2,     1,     1
};

static const short yydefact[] = {     2,
     0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     3,     6,     7,     0,
     0,     0,     0,     8,    10,     0,     0,     0,    57,     0,
    56,     0,    12,     0,     0,    14,     4,    71,    72,    17,
    18,    65,    66,    67,    68,    19,    30,     0,     0,    21,
     0,     0,    76,    24,     0,    25,    75,    26,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    69,    70,    22,    64,     0,     0,    61,     0,
     0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
     9,     0,    27,     0,    40,    11,     0,    38,    20,    58,
    73,    59,    60,    62,    63,     0,     0,     0,     0,     0,
     0,     0,    44,    13,     0,    42,     0,    31,    32,    33,
    34,    35,    36,    37,    28,    41,    39,    74,    45,    46,
    47,    48,    49,    50,    51,    43,     0,     0,     0,    15,
     2,     0,     0,     5,     6,     0,    16,     4,     0,     0,
     0
};

static const short yydefgoto[] = {   159,
     1,    17,    18,    47,    48,    55,    19,    59,   151,    20,
    67,    68,    70,    71,    90,    91,   153,    30,    31,    82,
    46,    75,    40,   113,    58,    54
};

static const short yypact[] = {-32768,
    53,-32768,   -35,   -11,    -2,     5,    32,    -1,     1,    13,
   -36,    41,    55,    64,    78,    75,-32768,-32768,-32768,    74,
   -33,   -33,    68,-32768,-32768,    69,    67,    70,-32768,    81,
-32768,    71,-32768,   -33,    73,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -13,    96,    79,-32768,
   -21,    12,-32768,-32768,    77,-32768,-32768,-32768,   113,    87,
    88,    89,    91,    92,    93,    94,     0,    95,    97,    10,
    98,    84,-32768,-32768,-32768,-32768,   -33,     3,-32768,   -36,
    73,-32768,    99,   100,   102,   103,   104,   105,   106,     2,
   107,   108,   -33,   -33,   -33,   -33,   -33,   -33,    68,-32768,
-32768,   109,-32768,    68,-32768,-32768,   110,-32768,-32768,-32768,
-32768,-32768,    85,-32768,-32768,   -33,   -33,   -33,   -33,   -33,
   -33,   -33,-32768,-32768,   111,-32768,   112,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   114,   115,   116,-32768,
   118,    76,   119,   120,   122,   124,-32768,   126,   144,   146,
-32768
};

static const short yypgoto[] = {-32768,
    -3,-32768,    14,-32768,-32768,-32768,-32768,-32768,-32768,    15,
-32768,    86,-32768,    82,-32768,    65,-32768,    90,-32768,-32768,
   -62,-32768,   -22,-32768,   101,-32768
};


#define	YYLAST		182


static const short yytable[] = {    41,
   100,    21,   123,    60,    61,    62,    63,    64,    65,    66,
   105,    56,    76,    38,    39,    29,    60,    61,    62,    63,
    64,    65,    66,    73,    74,    22,    83,    84,    85,    86,
    87,    88,    89,    69,    23,    26,   134,    27,   101,   -30,
   124,   136,    24,    77,    78,    79,    80,    81,   106,    28,
   111,   112,    -1,     2,   110,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    25,
   128,   129,   130,   131,   132,   133,   154,    32,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    33,   139,   140,   141,   142,   143,   144,   145,
    34,    83,    84,    85,    86,    87,    88,    89,    42,    43,
    44,    45,    36,    37,    35,    50,    49,    52,    51,    69,
    92,    53,    57,    93,    94,    95,    72,    96,    97,    98,
    99,   109,   138,   104,   103,   116,   117,   108,   118,   119,
   120,   121,   122,   160,   127,   161,   126,   152,   135,   137,
   146,   107,   102,     0,   125,   150,   -52,   157,   -55,   147,
   -53,   148,   149,   158,   -54,   155,   156,     0,     0,   114,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   115
};

static const short yycheck[] = {    22,
     1,    37,     1,    17,    18,    19,    20,    21,    22,    23,
     1,    34,     1,    47,    48,    52,    17,    18,    19,    20,
    21,    22,    23,    45,    46,    37,    25,    26,    27,    28,
    29,    30,    31,    24,    37,    37,    99,    37,    39,    40,
    39,   104,    38,    32,    33,    34,    35,    36,    39,    37,
    48,    49,     0,     1,    77,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    38,
    93,    94,    95,    96,    97,    98,     1,    37,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    38,   116,   117,   118,   119,   120,   121,   122,
    37,    25,    26,    27,    28,    29,    30,    31,    41,    42,
    43,    44,    38,    40,    37,    49,    48,    37,    49,    24,
     8,    51,    50,    37,    37,    37,    48,    37,    37,    37,
    37,    48,    48,    37,    40,    37,    37,    40,    37,    37,
    37,    37,    37,     0,    37,     0,    40,   151,    40,    40,
    40,    70,    67,    -1,    90,    40,    39,    39,    39,    48,
    39,    48,    48,    40,    39,   152,   152,    -1,    -1,    80,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    81
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 8:
#line 121 "yaccan.y"
{
		  StartGroup(4);
		;
    break;}
case 9:
#line 125 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_COS);
		;
    break;}
case 10:
#line 129 "yaccan.y"
{
		  StartGroup(5);
		;
    break;}
case 11:
#line 133 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_NIL);
		;
    break;}
case 12:
#line 137 "yaccan.y"
{
		  StartGroup(17);
		;
    break;}
case 13:
#line 141 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_BPI);
		;
    break;}
case 14:
#line 147 "yaccan.y"
{
		  if (DefiningVendorSpecific) {
		    fprintf(stderr, "Recursive definition of vendor specific information");
		  }
		  DefiningVendorSpecific = 1;
		  StartGroup(43);
		;
    break;}
case 15:
#line 155 "yaccan.y"
{
		  WriteByte(8); /* type */
		  WriteByte(3); /* length */
		  WriteByte(yyvsp[-3].byte_val);
		  WriteByte(yyvsp[-2].byte_val);
		  WriteByte(yyvsp[-1].byte_val);
		;
    break;}
case 16:
#line 163 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_VendorSpecificInfo);
		  DefiningVendorSpecific = 0;
		;
    break;}
case 17:
#line 169 "yaccan.y"
{
		  unsigned long rem = yyvsp[0].ulong_val % 62500;
		  if (rem != 0) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "down_freq = %lu is not a multiple of 62500 Hz, ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val -= rem;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		    
		  }
		  WriteByte(1); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		  ReportCMTS_MIC_Data(eCMTS_MIC_DownFreq, NextWritePosition()-6, 6);
		;
    break;}
case 18:
#line 188 "yaccan.y"
{
		  if (yyvsp[0].ulong_val > 0xff) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "UP_CHAN_ID %lu out of range, valid range is [0..255], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 0xff;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(2); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		  ReportCMTS_MIC_Data(eCMTS_MIC_UpChanId, NextWritePosition()-3, 3);
		;
    break;}
case 19:
#line 205 "yaccan.y"
{
		  WriteByte(3); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].bool_val? 1:0, 1);
		  ReportCMTS_MIC_Data(eCMTS_MIC_NetworkAccess, NextWritePosition()-3, 3);
		;
    break;}
case 20:
#line 212 "yaccan.y"
{
		  WriteByte(8); /* type */
		  WriteByte(3); /* length */
		  WriteByte(yyvsp[-2].byte_val); /* byte 1 */
		  WriteByte(yyvsp[-1].byte_val); /* byte 2 */
		  WriteByte(yyvsp[0].byte_val); /* byte 3 */
		;
    break;}
case 21:
#line 220 "yaccan.y"
{
		  char *name = yyvsp[0].string_val;
		  int len = strlen(name);
		  if (len>0xff) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "upgrade_filename too long, shortening to 255 characters\n"
		    );
		    len=0xff;
		  }
		  WriteByte(9); /* type */
		  WriteByte((byte)(len & 0xff)); /* length */
		  WriteString(name, len);
		  free(name);
		;
    break;}
case 22:
#line 237 "yaccan.y"
{
		;
    break;}
case 23:
#line 240 "yaccan.y"
{
		  /* the first char in string snmp_obj_id gives the length */
		  int mib_len_pos;
		  int seq_len_pos;
		  int obj_id_len = (int)yyvsp[-2].string_val[0];
		  byte *obj_id = (byte *)yyvsp[-2].string_val+1;
		  int value_len = (int)yyvsp[0].string_val[0];
		  byte *value = (byte *)yyvsp[0].string_val+1;
		  

		  WriteByte(11); /* type = SNMP MIB Object */
		  mib_len_pos = NextWritePosition();
		  WriteByte(0); /* dummy for SNMP MIB Object length */

		  WriteByte(0x30); /* type = SEQUENCE */
		  seq_len_pos = NextWritePosition();
		  WriteByte(0); /* dummy for SEQUENCE length */

		  WriteByte(0x06); /* type = OBJECT IDENTIFIER */
		  WriteByte((byte)(obj_id_len & 0xff));
		  WriteString(obj_id, obj_id_len);

		  WriteString(value, value_len);

		  WriteByteAtPosition(seq_len_pos, (byte)(NextWritePosition()-seq_len_pos-1));
		  WriteByteAtPosition(mib_len_pos, (byte)(NextWritePosition()-mib_len_pos-1));
 
		  free(yyvsp[-2].string_val);
		  free(yyvsp[0].string_val);
		;
    break;}
case 24:
#line 271 "yaccan.y"
{
		  WriteByte(14); /* type */
		  WriteByte(6); /* length */
		  WriteString(yyvsp[0].string_val, 6);
		  free(yyvsp[0].string_val);
		;
    break;}
case 25:
#line 278 "yaccan.y"
{
		  if (yyvsp[0].ulong_val > 0xff) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "max_num_cpe %lu out of range, valid range is [0..255], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 0xff;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(18); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		  ReportCMTS_MIC_Data(eCMTS_MIC_MaxNumCpe, NextWritePosition()-3, 3);
		;
    break;}
case 26:
#line 295 "yaccan.y"
{
		  WriteByte(21); /* type */
		  WriteByte(4); /* length */
		  WriteString(yyvsp[0].string_val, 4);
		  free(yyvsp[0].string_val);
		;
    break;}
case 31:
#line 309 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>16) {
		    yyerror(NULL);
		    fprintf(	
		      stderr, 
		      "class_id %lu out of range, valid range is [1..16], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 16;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(1); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		;
    break;}
case 32:
#line 325 "yaccan.y"
{
		  WriteByte(2); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 33:
#line 331 "yaccan.y"
{
		  WriteByte(3); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 34:
#line 337 "yaccan.y"
{
		  if (yyvsp[0].ulong_val>7) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "up_chan_prio %lu out of range, valid range is [0..7], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 7;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(4); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		;
    break;}
case 35:
#line 353 "yaccan.y"
{
		  WriteByte(5); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 36:
#line 359 "yaccan.y"
{
		  if (yyvsp[0].ulong_val > 1518) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "max_burst_size %lu out of range, valid range is [0..1518], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 1518;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(6); /* type */
		  WriteByte(2); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 2);
		;
    break;}
case 37:
#line 375 "yaccan.y"
{
		  WriteByte(7); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].bool_val? 1:0, 1);
		;
    break;}
case 41:
#line 388 "yaccan.y"
{
		  WriteByte(1); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].bool_val? 1:0, 1);
		;
    break;}
case 45:
#line 400 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>30) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "authorize_wait_timeout %lu out of range, valid range is [1..30], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 30;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(1); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 46:
#line 416 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>20) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "reauthorize_wait_timeout %lu out of range, valid range is [1..20], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 20;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(2); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 47:
#line 432 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>1800) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "authorization_grace_time %lu out of range, valid range is [1..1800], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 1800;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(3); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 48:
#line 448 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>10) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "operational_wait_timeout %lu out of range, valid range is [1..10], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 10;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(4); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 49:
#line 464 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>10) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "rekey_wait_timeout %lu out of range, valid range is [1..10], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 10;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(5); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 50:
#line 480 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>1800) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "tek_grace_time %lu out of range, valid range is [1..1800], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 1800;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(6); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 51:
#line 496 "yaccan.y"
{
		  WriteByte(7); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 56:
#line 510 "yaccan.y"
{
		  /* Now I can correct the encoding of the first two sub_obj_ids. */
		  /* The first char in string snmp_obj_id gives the length */
		  int obj_id_len = (int)yyvsp[0].string_val[0];
		  byte *obj_id = (byte *)yyvsp[0].string_val+1;
		  if (obj_id[0] > 2) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "illegal value %d of first sub-identifier in SNMP Object Id, valid range is [1..3], ",
		      (int)obj_id[0]
		    );
		    obj_id[0] = 1;
		  }
		  if (obj_id[1] > 39) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "illegal value %d of first sub-identifier in SNMP Object Id, valid range is [1..39], ",
		      (int)obj_id[1]
		    );
		    obj_id[1] = 39;
		  }
		  obj_id[1] = obj_id[0]*40 + obj_id[1];
		  obj_id_len--;
		  /* shift sequence one byte to the left */
		  memmove(obj_id, obj_id+1, obj_id_len);
		  /* write back new length */
		  obj_id[-1] = obj_id_len;
		  yyval.string_val = yyvsp[0].string_val;
		;
    break;}
case 57:
#line 544 "yaccan.y"
{
		  /* we return a string with its length being encoded in
		     its first char */
		  /* Correct of the encoding of the first two sub_obj_ids
		     is done by snmp_obj_id */
		  int in_cnt = 0;
		  int out_cnt = 1;
		  char *input = yyvsp[0].string_val;
		  byte *buffer = (byte*)malloc(strlen(input)*3+4);

		  while (1) {
		    unsigned long su_obj_id = 0;
		    char c;

		    /* read the next integer */
		    while (1) {
		      c = input[in_cnt++];
		      if (c=='\0' || c=='.') break;
		      su_obj_id = su_obj_id*10 + c-'0';
		    }

		    /* write it to buffer */
		    if (su_obj_id>0x0fffffff) buffer[out_cnt++] =
						(byte)((su_obj_id>>28 & 0x7f) | 0x80);
		    if (su_obj_id>0x001fffff) buffer[out_cnt++] =
						(byte)((su_obj_id>>21 & 0x7f) | 0x80);
		    if (su_obj_id>0x00003fff) buffer[out_cnt++] =
						(byte)((su_obj_id>>14 & 0x7f) | 0x80);
		    if (su_obj_id>0x0000007f) buffer[out_cnt++] =
						(byte)((su_obj_id>>7  & 0x7f) | 0x80);
		    if (1                   ) buffer[out_cnt++] =
						(byte)((su_obj_id     & 0x7f)       );

		    if (c=='\0') break; 
		    if (c!='.') {
		      yyerror(NULL);
		      fprintf(stderr,"syntax SNMP object identifier `%s'", input);
		      break;
		    }
		  }
		  buffer[0] = out_cnt-1;
		  yyval.string_val = buffer;

		  free(input);
		;
    break;}
case 58:
#line 592 "yaccan.y"
{
		  /* return type is a non-null-terminated string with the
		   * first char giving its length.
		   * This item is only for positiv numbers!!!
		   */
		  unsigned long val = yyvsp[0].ulong_val;
		  int out_cnt = 1;
		  byte *buffer = (byte*)malloc(7);

		  buffer[out_cnt++] = 0x02; /* type = INTEGER */
		  buffer[out_cnt++] = 0; /* value length will be filled in later */
		  if (val>0x007fffff) buffer[out_cnt++] = (byte)(val>>24 & 0xff);
		  if (val>0x00007fff) buffer[out_cnt++] = (byte)(val>>16 & 0xff);
		  if (val>0x0000007f) buffer[out_cnt++] = (byte)(val>> 8 & 0xff);
		  if (1             ) buffer[out_cnt++] = (byte)(val     & 0xff);
		  buffer[2] = out_cnt-3; /* value length */
		  buffer[0] = out_cnt-1; /* string length */
		  yyval.string_val = buffer;
		;
    break;}
case 59:
#line 612 "yaccan.y"
{
		  int len = strlen(yyvsp[0].string_val);
		  byte *buffer = (byte*)malloc(len+3);

		  buffer[0] = len+2; /* string length */
		  buffer[1] = 0x04; /* type = OCTET STRING */
		  buffer[2] = len;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val, len);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 60:
#line 624 "yaccan.y"
{
		  int len = yyvsp[0].string_val[0];
		  byte *buffer = (byte*)malloc(len+3);

		  buffer[0] = len+2; /* string length */
		  buffer[1] = 0x04; /* type = OCTET STRING */
		  buffer[2] = len;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val+1, len);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 61:
#line 636 "yaccan.y"
{
		  byte *buffer = (byte*)malloc(3);
		  buffer[0] = 2;    /* string length */
		  buffer[1] = 0x05; /* type = NULL */
		  buffer[2] = 0;    /* value length */
		  yyval.string_val = buffer;
		;
    break;}
case 62:
#line 644 "yaccan.y"
{
		  int len = yyvsp[0].string_val[0];
		  byte *buffer = (byte*)malloc(len+3);

		  buffer[0] = len+2; /* string length */
		  buffer[1] = 0x06; /* type = OBJECT ID */
		  buffer[2] = len;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val+1, len);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 63:
#line 656 "yaccan.y"
{
		  byte *buffer = (byte*)malloc(7);

		  buffer[0] = 6; /* string length */
		  buffer[1] = 0x40; /* type = IpAddress */
		  buffer[2] = 4;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val, 4);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 64:
#line 667 "yaccan.y"
{
		  byte *buffer = (byte*)malloc(1);
		  buffer[0] = 0;
		  yyval.string_val = buffer;
		;
    break;}
case 65:
#line 675 "yaccan.y"
{
		  yyval.bool_val = 1;
		;
    break;}
case 66:
#line 679 "yaccan.y"
{
		  yyval.bool_val = 0;
		;
    break;}
case 67:
#line 683 "yaccan.y"
{
		  yyval.bool_val = 1;
		;
    break;}
case 68:
#line 687 "yaccan.y"
{
		  yyval.bool_val = 0;
		;
    break;}
case 69:
#line 693 "yaccan.y"
{
		  yyval.bool_val = 1;
		;
    break;}
case 70:
#line 697 "yaccan.y"
{
		  yyval.bool_val = 0;
		;
    break;}
case 72:
#line 704 "yaccan.y"
{
		  unsigned char c = yyvsp[0].byte_val;
		  yyval.ulong_val = (unsigned long)c;
		;
    break;}
case 73:
#line 711 "yaccan.y"
{
		  /* The first byte of the sequence gives its length.
		   * The length of the malloc block is always n*8+1
		   * Thus, sequence[0]==5 -> malloc(9)
		   *       sequence[0]==8 -> malloc(9)
		   *       sequence[0]==9 -> malloc(17)
		   *       etc.
		   */
		  byte *sequence = (byte *)malloc(9);
		  sequence[0] = 1;
		  sequence[1] = yyvsp[0].byte_val;
		  yyval.string_val = sequence;
		;
    break;}
case 74:
#line 726 "yaccan.y"
{
		  byte *sequence = (byte *)yyvsp[-1].string_val;
		  int len = sequence[0];
		  if (len%8 == 0) {
		    /* no more free bytes in malloc block, */
		    /* have to extend it by 8 byte */
		    int new_len = len+9;
		    byte *new_seq = (byte *)malloc(new_len);
		    memcpy(new_seq, sequence, len+1);
		    free(sequence);
		    sequence = new_seq;
		  }
		  sequence[0] = len+1;
		  sequence[len+1] = yyvsp[0].byte_val;
		  yyval.string_val = sequence;
		;
    break;}
case 75:
#line 745 "yaccan.y"
{
		  int byte_cnt;
		  int char_cnt = 0;
		  char *ip_addr = (char *)malloc(4);

		  for (byte_cnt=0; byte_cnt<4; byte_cnt++) {
		    int b = 0;
		    while (1) {
		      char c = yyvsp[0].string_val[char_cnt];
		      if (c=='\0' || c=='.') break;
		      b = b*10 + c-'0';
		      char_cnt++;
		    }
		    if (b > 0xff) {
		      int i;
		      yyerror(NULL);
		      fprintf(stderr,"syntax error in IP address string `%s'", yyvsp[0].string_val);
		      /* reset ip_addr */
		      for(i=0; i<4;i++) ip_addr[i] = 0;
		      break;
		    }
		    ip_addr[byte_cnt] = (char)b;
		    char_cnt++; /* jump over '.' */
		  }
		  yyval.string_val = ip_addr;
		  free(yyvsp[0].string_val);
		;
    break;}
case 76:
#line 775 "yaccan.y"
{
		  int byte_cnt;
		  int char_cnt = 0;
		  char *mac_addr = (char *)malloc(6);

		  for (byte_cnt=0; byte_cnt<6; byte_cnt++) {
		    int b = 0;
		    while (1) {
		      char c = yyvsp[0].string_val[char_cnt];
		      if (c=='\0' || c==':') break;
		      if (c>='0' && c<='9') c -= '0';
		      else if (isalpha(c))  c = toupper(c) - 'A' + 10;
		      b = b*16 + c;
		      char_cnt++;
		    }
		    mac_addr[byte_cnt] = (char)b;
		    char_cnt++; /* jump over ':' */
		  }
		  yyval.string_val = mac_addr;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 797 "yaccan.y"


void yyerror (const char* s) {
  fprintf (stderr, "%s:%d: ", YYSourceName, YYLineNo);
  if (s) fprintf(stderr, "%s\n", s);
}


/* {{{ Local variables */

/*
  Local variables:
  folded-file: t
  c-basic-offset: 2
  End:
*/

/* }}} */
